Subject: Re: pthread_create -- no callback?
From: "Lassi A. Tuura" <[email-masked]>
To: Evan Pollan <[email-masked]>
Cc: [email-masked]
Date: Wed, 14 Nov 2001 16:28:21 +0100

> The sample I included did check the return value of pthread_join.

Nope, you are still not printing pthread_join *return* value -- print
the int returned by pthread_join as you did with pthread_create.  On
linux it returns ESRCH = no such thread.  Your problem is with the
thread argument to pthread_join as shown below.

Since you are not joining with the thread, the output might disappear. 
My guess is that the main thread finishes execution and the stdout gets
closed before the second thread executes, and hence you see no output
from the other thread.  That doesn't happen on linux as you can see
below, but maybe it is reasonable behaviour on windows.  If you think it
is a bug, I am sure cygwin authors would appreciate a patch ;-)

Your code:
>     void* threadExitStatus;
>     cout << "--> pthread_join()\n";
>     pthread_join(&thread, &threadExitStatus);
>     cout << "<-- pthread_join():" << (int)threadExitStatus << "\n";

Change this to:
      retVal = pthread_join(&thread, &threadExitStatus);
      cout << "<-- pthread_join():" << retVal
           << " " << (int)threadExitStatus << "\n";

I would have expected you to see this in your compilation:
/tmp/foo.cxx:24: warning: passing `pthread_t *' to argument 1 of
    `pthread_join(long unsigned int, void **)' lacks a cast

Output with my changes (on linux):
$ ./a.out
--> pthread_create()
<-- pthread_create():0
--> pthread_join()
<-- pthread_join():3 1075347592
--> callbackFunction(0x8048b9b)
$ grep ESRCH /usr/include/asm/errno.h 
#define ESRCH            3      /* No such process */

HTH,
//lat
-- 
Those who cannot remember the past are condemned to repeat it.
	--George Santayana

--
Unsubscribe info:      http://cygwin.com/ml/#unsubscribe-simple
Bug reporting:         http://cygwin.com/bugs.html
Documentation:         http://cygwin.com/docs.html
FAQ:                   http://cygwin.com/faq/